//+------------------------------------------------------------------+
//|                                               Advanced forecater |
//|                                                                  |
///+-----------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Black
#property indicator_color2 Black
#property indicator_color3 Black

extern int FastEma    = 13;
extern int SlowEma    = 34;
extern int SignalSMA  = 8;
input color linecolor = DeepSkyBlue;
extern int linewidth  = 2;

double Buff_up[];
double Buff_dn[];
double sum[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init() {
   
   IndicatorShortName("Advanced_forecater");
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, linewidth, linecolor);
   SetIndexBuffer(0, Buff_up);
   SetIndexBuffer(1, Buff_dn);
   SetIndexBuffer(2, sum);
   IndicatorDigits(0);
   return (0);
}

//+------------------------------------------------------------------+
//| Advanced_forecater calculations                             |
//+------------------------------------------------------------------+

int start() {
   int Limit;
   bool CalculateValue = FALSE; 
   int counted_bars = IndicatorCounted();
      if (counted_bars > 0) counted_bars--;
      if (CalculateValue)Limit= Bars - counted_bars;
          else Limit = Bars;
   
   for (int shift = 0; shift < Limit; shift++) {
      Buff_up[shift] = EMPTY_VALUE;
      Buff_dn[shift] = iMA(NULL, 0, FastEma, 0, MODE_EMA, PRICE_CLOSE, shift) - iMA(NULL, 0, SlowEma, 0, MODE_EMA, PRICE_CLOSE, shift);
   }
   
   double Multiply_Factor_1 = 2.0 / (FastEma + 1.0);
   double Multiply_Factor_2 = 2.0 / (SlowEma + 1.0);
   double Multiply_Factor_3 = Multiply_Factor_1 - Multiply_Factor_2;
   
   for (shift = 0; shift < Limit; shift++) sum[shift] = iMAOnArray(Buff_dn, Bars, SignalSMA, 0, MODE_SMA, shift);
   for (shift = 0; shift < Limit; shift++) {
      if (MathAbs(Multiply_Factor_3) > 0.0) {
         Buff_up[shift] = (Multiply_Factor_1 * iMA(NULL, 0, FastEma, 0, MODE_EMA, PRICE_CLOSE, shift) + iMA(NULL, 0, SlowEma, 0, MODE_EMA, PRICE_CLOSE, shift) - iMA(NULL,
            0, FastEma, 0, MODE_EMA, PRICE_CLOSE, shift) - Multiply_Factor_2 * iMA(NULL, 0, SlowEma, 0, MODE_EMA, PRICE_CLOSE, shift) + sum[shift]) / Multiply_Factor_3;
      } else Buff_up[shift] = 0;
   }
   if (shift > 100) CalculateValue = TRUE;
   return (0);
}